//atiny seteada en 8mhz

#define HUE 0    //output pwm
#define RED 3    //output led control  digital
#define GREEN 4  //output led control digital
#define BLUE 1   //output led control digital
#define LDR 1    //input analog LDR
#define BASICCOLORS 3
#define PAUSEbREAD 50
#define PAUSEaREAD 10
#define FAIL 255

//los valores de los colores en el array rgb deben estar en el siguiente orden: 0:rojo, 1:verde, 2:azul
int rgb[BASICCOLORS];
int rgbPins[] = {RED, GREEN, BLUE};

//los valores de los colores en el array hsv deben estar en el siguiente orden: 0:h, 1:s, 2:v
double hsv[BASICCOLORS];


void setup() {

  for (int i=0;i<BASICCOLORS;i++){
    pinMode(rgbPins[i], OUTPUT);
    digitalWrite(rgbPins[i], LOW);  
  }
  //Serial.begin(115200);
}

int leerColorBase(int pinColor){
    digitalWrite(pinColor, HIGH);
    delay(PAUSEbREAD);
    int color = map(analogRead(LDR), 0, 1023, 0, 255);
    //Serial.println(color);
    delay(PAUSEaREAD);  
    digitalWrite(pinColor, LOW);
    return color;
  }

// the loop function runs over and over again forever
void loop() {
  bool ok;
  //Serial.println();
  for (int i=0;i<BASICCOLORS;i++){    
    rgb[i] = leerColorBase(rgbPins[i]);       
  }
  ok = rgb2hsv(rgb, hsv);
  
  if (!ok) analogWrite (HUE, FAIL);//Serial.println("error");
  else     analogWrite (HUE, hsv[0]);//printHsv(hsv);
}
